// NEO ENGINE



#define SAVE 0
#define RESTORE 1

char *virtual1, *virtual2;	// initialize virtuals
char *gray1, *gray2;				// Initialize grays
char neo_abort=0;						// Abort code for neo

INT_HANDLER save_int_1;


////////////////////////////////////////////////////////////////////////////////////////////////
// Pause routine...need to integrate and escape sequence
// yeah...i could have used a system timer...but this is effective
////////////////////////////////////////////////////////////////////////////////////////////////
void pause(unsigned int length) {
	unsigned int i;
	for(i=0;i<256*length;i++) {}
}





////////////////////////////////////////////////////////////////////////////////////////////////
// Replacement for my only needs of ngetchx()
////////////////////////////////////////////////////////////////////////////////////////////////
void wait_for_enter_or_escape(void) {
	char exitloop=0;
	while(_rowread(ENTER_ROW)&ENTER_KEY);
	while(exitloop==0) {
		if(_rowread(ENTER_ROW)&ENTER_KEY) exitloop++;
		if(_rowread(ESC_ROW)&ESC_KEY) exitloop++;
		if(_rowread(ARROWS_ROW)&SECOND_KEY) exitloop++;}
	while(_rowread(ESC_ROW)&ESC_KEY);
}





////////////////////////////////////////////////////////////////////////////////////////////////
// Control interupt 1 functions: redirect and restore later
////////////////////////////////////////////////////////////////////////////////////////////////
void Control_int_1(char SorR_state){
	if(SorR_state==SAVE){
		save_int_1 = GetIntVec (AUTO_INT_1);
		SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
		GrayOn();}
	if(SorR_state==RESTORE){
		GrayOff();
		SetIntVec (AUTO_INT_1, save_int_1);
	}
}





////////////////////////////////////////////////////////////////////////////////////////////////
// Neo Sprite Sub routine: 8,16,32 bit
////////////////////////////////////////////////////////////////////////////////////////////////
	void Neo_Sprite8(int x,int y,int height,char *sprite, void *plane){
		int i;char buffer[height];y=y+32;
		if(y>0&&y<160&&x>-8&&x<240){
			if(x>=0&&x<240-8) Sprite8_OR(x,y,height,sprite,plane);
			if(x<0){
				for(i=0;i<height;i++) buffer[i]=sprite[i] << (0-x);
				Sprite8_OR(0,y,height,buffer,plane);}
			if(x>240-8){
				for(i=0;i<height;i++) buffer[i]=sprite[i] >> (x-240+8);
				Sprite8_OR(240-8,y,height,buffer,plane);}}}
	void Neo_Sprite16(int x,int y,int height,unsigned short *sprite, void *plane){
		int i;unsigned short buffer[height];y=y+32;
		if(y>0&&y<160&&x>-16&&x<240){
			if(x>=0&&x<240-16) Sprite16_OR(x,y,height,sprite,plane);
			if(x<0){
				for(i=0;i<height;i++) buffer[i]=sprite[i] << (0-x);
			Sprite16_OR(0,y,height,buffer,plane);}
			if(x>240-16){
				for(i=0;i<height;i++) buffer[i]=sprite[i] >> (x-240+16);
				Sprite16_OR(240-16,y,height,buffer,plane);}}}
	void Neo_Sprite32(int x,int y,int height,unsigned long *sprite, void *plane){
		int i;unsigned long buffer[height];y=y+32;
		if(y>0&&y<160&&x>-32&&x<240){
			if(x>=0&&x<240-32) Sprite32_OR(x,y,height,sprite,plane);
			if(x<0){
				for(i=0;i<height;i++) buffer[i]=sprite[i] << (0-x);
				Sprite32_OR(0,y,height,buffer,plane);}
			if(x>240-32){
				for(i=0;i<height;i++) buffer[i]=sprite[i] >> (x-240+32);
				Sprite32_OR(240-32,y,height,buffer,plane);}}}
	void Neo_Sprite8m(int x,int y,int height,unsigned char *sprite, void *plane){
		int i;unsigned char buffer[height];y=y+32;
		if(y>0&&y<160&&x>-8&&x<240){
			for(i=0;i<height;i++) buffer[i]=~sprite[i];
			if(x>=0&&x<240-8) Sprite8_AND(x,y,height,buffer,plane);
			if(x<0){
				for(i=0;i<height;i++) buffer[i]=buffer[i] << (0-x);
			Sprite8_AND(0,y,height,buffer,plane);}
			if(x>240-8){
				for(i=0;i<height;i++) buffer[i]=buffer[i] >> (x-240+8);
				Sprite8_AND(240-8,y,height,buffer,plane);}}}





////////////////////////////////////////////////////////////////////////////////////////////////
// copies virtual (without upper and bottom clip area) to gray planes
////////////////////////////////////////////////////////////////////////////////////////////////
void neo_display(){
	//memcpy(gray1,virtual1+960,3840);	// Copy from virtual1 to gray1
	//memcpy(gray2,virtual2+960,3840);	// Copy from virtual2 to gray2
	FastCopyScreen(virtual1+960,gray1);	// 13% increase in speed!
	FastCopyScreen(virtual2+960,gray2);	//
}





////////////////////////////////////////////////////////////////////////////////////////////////
// clears virtual for next frame
////////////////////////////////////////////////////////////////////////////////////////////////
void neo_next(){
	//memset(virtual1+960,0,3840);	// clear virtual1
	//memset(virtual2+960,0,3840);	// clear virtual2
	ClearGrayScreen2B(virtual1+960,virtual2+960); // 13% increase in speed!
}





////////////////////////////////////////////////////////////////////////////////////////////////
// start neo engine
////////////////////////////////////////////////////////////////////////////////////////////////
char neo_start(){
	if(HeapAvail()<5760*2) {neo_abort++;return 0;}	// Check mem, return unsuccessful
	virtual1 = malloc(5760);	// ((32+32+240)/8)*(128+32+32) : 32=buffer for l,r,t,b of virtual 
	virtual2 = malloc(5760);	// (to not slow down for bitshifting routines..speed not memory)
	gray1 = GetPlane(0);			// pointer to Gray Plane 0
	gray2 = GetPlane(1);			// pointer to Gray Plane 1
	return 1;									// return successful
}





////////////////////////////////////////////////////////////////////////////////////////////////
// end neo engine
////////////////////////////////////////////////////////////////////////////////////////////////
void neo_end(){
	if(!neo_abort) {
		free(virtual1);
		free(virtual2);
	}
}
